﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Infragistics.Windows.DataPresenter;

namespace WpfApplication40
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        
        public MainWindow()
        {
            InitializeComponent();
            grid1.FieldLayoutInitialized += new EventHandler<Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs>(grid1_FieldLayoutInitialized);
        }


        private FieldLayout masterLayout;

        void grid1_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            
            //foreach (var field in e.FieldLayout.Fields)
            //{


            //    switch (field.Name)
            //    {
            //        case "Name":
            //            field.Label = "Security Desc";
            //            field.ActualPosition = new FieldPosition(1, 0, 0, 0);
            //            break;
            //        case "ID":
            //            field.Visibility = Visibility.Collapsed;
            //            break;
            //        case "PID":
            //            field.Visibility = Visibility.Collapsed;
            //            break;
            //        case "Age":
            //            field.ActualPosition = new FieldPosition(0, 0, 0, 0);
            //            break;

            //    }
            //}

            
            var index = grid1.FieldLayouts.IndexOf(e.FieldLayout);
            if(index == 0)
            {
                masterLayout = e.FieldLayout;

            }
            else
            {
                e.FieldLayout.Settings.LabelLocation = LabelLocation.Hidden;

            /*    var parentFieldLayout = grid1.FieldLayouts[index - 1];



                var firstVisibleParent = parentFieldLayout.Fields.FirstOrDefault(f => f.Visibility == Visibility.Visible && f.ActualPosition.Column == 0);

                var firstVisible = e.FieldLayout.Fields.FirstOrDefault(f => f.Visibility == Visibility.Visible && f.ActualPosition.Column == 0);
                firstVisible.Width = new FieldLength(firstVisible.CellWidthResolved - 17 * index);*/
            }

            //e.FieldLayout.RecordIndentVersion

        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {

            try
            {
                DataSet data = new DataSet();

                DataTable table1 = new DataTable();

                DataColumn colid11 = new DataColumn();
                colid11.ColumnName = "ID";
                colid11.DataType = typeof(int);
                table1.Columns.Add(colid11);
                DataColumn col12 = new DataColumn();
                col12.ColumnName = "Name";
                col12.DataType = typeof(string);
                table1.Columns.Add(col12);
                DataColumn col13 = new DataColumn();
                col13.ColumnName = "Age";
                col13.DataType = typeof(int);
                table1.Columns.Add(col13);

                DataColumn colid14 = new DataColumn();
                colid14.ColumnName = "ParentID";
                colid14.DataType = typeof(int);
                table1.Columns.Add(colid14);

                table1.Columns.Add(new DataColumn("Pnl") { DataType = typeof(string) });
                table1.Columns.Add(new DataColumn("PositionSize") { DataType = typeof(string) });
                table1.Columns.Add(new DataColumn("Price") { DataType = typeof(string) });


                DataTable table2 = new DataTable();
                //table1.TableName = "R";

                DataColumn colid21 = new DataColumn();
                colid21.ColumnName = "ID";
                colid21.DataType = typeof(int);
                table2.Columns.Add(colid21);
                DataColumn col22 = new DataColumn();
                col22.ColumnName = "Name";
                col22.DataType = typeof(string);
                table2.Columns.Add(col22);
                DataColumn col23 = new DataColumn();
                col23.ColumnName = "Age";
                col23.DataType = typeof(int);
                table2.Columns.Add(col23);

                DataColumn colid24 = new DataColumn();
                colid24.ColumnName = "ParentID";
                colid24.DataType = typeof(int);
                table2.Columns.Add(colid24);
                table2.Columns.Add(new DataColumn("Pnl") { DataType = typeof(string) });
                table2.Columns.Add(new DataColumn("PositionSize") { DataType = typeof(string) });
                table2.Columns.Add(new DataColumn("Price") { DataType = typeof(string) });



                DataTable table3 = new DataTable();
                //table1.TableName = "R";

                DataColumn colid31 = new DataColumn();
                colid31.ColumnName = "ID";
                colid31.DataType = typeof(int);
                table3.Columns.Add(colid31);
                DataColumn col32 = new DataColumn();
                col32.ColumnName = "Name";
                col32.DataType = typeof(string);
                table3.Columns.Add(col32);
                DataColumn col33 = new DataColumn();
                col33.ColumnName = "Age";
                col33.DataType = typeof(int);
                table3.Columns.Add(col33);
                DataColumn colid34 = new DataColumn();
                colid34.ColumnName = "ParentID";
                colid34.DataType = typeof(int);
                table3.Columns.Add(colid34);
                table3.Columns.Add(new DataColumn("Pnl") { DataType = typeof(string) });
                table3.Columns.Add(new DataColumn("PositionSize") { DataType = typeof(string) });
                table3.Columns.Add(new DataColumn("Price") { DataType = typeof(string) });


                DataTable table4 = new DataTable();
                //table1.TableName = "R";

                DataColumn colid41 = new DataColumn();
                colid41.ColumnName = "ID";
                colid41.DataType = typeof(int);
                table4.Columns.Add(colid41);
                DataColumn col42 = new DataColumn();
                col42.ColumnName = "Name";
                col42.DataType = typeof(string);
                table4.Columns.Add(col42);
                DataColumn col43 = new DataColumn();
                col43.ColumnName = "Age";
                col43.DataType = typeof(int);
                table4.Columns.Add(col43);
                DataColumn colid44 = new DataColumn();
                colid44.ColumnName = "ParentID";
                colid44.DataType = typeof(int);
                table4.Columns.Add(colid44);
                table4.Columns.Add(new DataColumn("Pnl"){DataType = typeof(string)});
                table4.Columns.Add(new DataColumn("PositionSize") { DataType = typeof(string) });
                table4.Columns.Add(new DataColumn("Price") { DataType = typeof(string) });

                data.Tables.Add(table1);
                data.Tables.Add(table2);
                data.Tables.Add(table3);
                data.Tables.Add(table4);

                data.Relations.Add(new DataRelation("L1", colid11, colid24));
                data.Relations.Add(new DataRelation("L2", colid21, colid34));
                data.Relations.Add(new DataRelation("L3", colid31, colid44));



                table1.Rows.Add(new object[] { 1, "L1", 21 ,null,"Pnl1","PS2","Price3"});
                table1.Rows.Add(new object[] { 2, "L2", 52,null, "Pnl1", "PS2", "Price3" });
                table1.Rows.Add(new object[] { 3, "L3", 37,null, "Pnl1", "PS2", "Price3" });


                table2.Rows.Add(new object[] { 11, "L1.1", 21, 1, "Pnl1", "PS2", "Price3" });
                table2.Rows.Add(new object[] { 12, "L1.1", 21, 1, "Pnl1", "PS2", "Price3" });
                table2.Rows.Add(new object[] { 21, "L2.1", 21, 2, "Pnl1", "PS2", "Price3" });
                table2.Rows.Add(new object[] { 31, "L3.1", 21, 3, "Pnl1", "PS2", "Price3" });
                //table2.Rows.Add(new object[] { 13, "L1.3", 21 ,1});


                table3.Rows.Add(new object[] { 111, "L1.1.1", 21, 11, "Pnl1", "PS2", "Price3" });
                table3.Rows.Add(new object[] { 112, "L1.1.2", 21, 11, "Pnl1", "PS2", "Price3" });
                table3.Rows.Add(new object[] { 121, "L1.2.1", 21, 12, "Pnl1", "PS2", "Price3" });
                //table3.Rows.Add(new object[] {131, "L1.3.1", 21 ,13});
                //table3.Rows.Add(new object[] { 3, "L1.", 21 });



                table4.Rows.Add(new object[] { 1111, "L1.1.1.1", 21, 111, "Pnl1", "PS2", "Price3" });
                table4.Rows.Add(new object[] { 1121, "L1.1.2.1", 21, 112, "Pnl1", "PS2", "Price3" });
                table4.Rows.Add(new object[] { 1211, "L1.2.1.1", 21, 121, "Pnl1", "PS2", "Price3" });
                //table3.Rows.Add(new object[] {131, "L1.3.1", 21 ,13});
                //table3.Rows.Add(new object[] { 3, "L1.", 21 });
                

                grid1.DataSource = data.Tables[0].DefaultView;

                //grid1.
            }
            catch (Exception exception)
            {
                Console.WriteLine(exception);
            }            
        }
    }
}
